/**********************************************************
 * FILE: wft.h                                            *
 *       Main header file for the WFT decoding program    *
 *							  *
 * Author: Peter Rajcani, March 1995			  *
 **********************************************************/

#define MAX_STATES   2000
#define MAXDEPTH    9
#define SIMPLE	    1
#define GENERAL	    2
#define DSIZE	    256

typedef  float real;
typedef  float imgtype;

typedef struct edges {			/* edges form a linked list */
                real          weight;
                unsigned char label[2];
                int	      into;
		int	      from;
                struct edges  *next;
               } edgetype;

typedef struct tape_cell {
		char	      address[MAXDEPTH+1];
		float	      weight;
		struct tape_cell *next;
} tape;

typedef struct {
                float         *new,*old;/* new - vector of updated greyness
					         values;
					   old - vector of old greyness values*/
		tape          **old_tape, **new_tape;
		char	      *new_address, *old_address;
                edgetype      *edges;
		real	      initial, final;
		unsigned char depth;
} statetype;

typedef struct {
                int 	      states;
		int	      ntapes;
		int	      method;
		/*int	      scaling_flag;*/
                statetype     state[MAX_STATES];
} automaton;

